<VirtualHost *:80>
   ServerName {{ app_domain }}

   RewriteEngine On
   RewriteCond %{HTTPS} off
   RewriteRule ^(.*)$ https://%{HTTP_HOST}$1 [R=301,L]
</VirtualHost>

<IfModule mod_ssl.c>
   <VirtualHost *:443>

     ServerName {{ app_domain }}
     DocumentRoot {{ app_instance_root }}

     SetEnvIFNoCase User-Agent "Monit" dontlog
     CustomLog {{ www_log }}/{{ app_instance_id }}/access.log combined env=!dontlog
     ErrorLog {{ www_log }}/{{ app_instance_id }}/error.log

     RewriteEngine On
     SSLProxyEngine on
     ProxyPreserveHost On

     <Location />
           Require all granted
           ProxyPass http://localhost:{{ app_port }}/
           ProxyPassReverse http://localhost:{{ app_port }}/
           ProxyPassReverseCookieDomain localhost {{ app_domain }}
     </Location>

     RewriteCond %{REQUEST_URI} /api/v[0-9]+/(users/)?websocket [NC,OR]
     RewriteCond %{HTTP:UPGRADE} ^WebSocket$ [NC,OR]
     RewriteCond %{HTTP:CONNECTION} ^Upgrade$ [NC]
     RewriteRule .* ws://127.0.0.1:8065%{REQUEST_URI} [P,QSA,L]

     SSLEngine on
     SSLCertificateFile /etc/letsencrypt/live/{{ app_domain }}/fullchain.pem
     SSLCertificateKeyFile /etc/letsencrypt/live/{{ app_domain }}/privkey.pem

     </VirtualHost>
</IfModule>
